/***********************************************************************
  Este fichero es parte de BeHA, un compresor de proposito general.
  Copyright (C) 2000 Industrias O.S.G.
  Copyright (C) 1995 Harri Hirvola

  Este programa es software libre; puedes redistribuirlo y/o modificarlo
  bajo los terminos de la Licencia Publica General GNU (GNU/GPL) publicada
  por la Fundacion de Software Libre (FSF); sea la versin 2 de la Licencia,
  o (a tu opinion) o cualquier version posterior.

  Este programa es distribuido con la esperanza de que sea util, pero
  SIN NINGUNA GARANTIA. Mira los terminos de la Licencia Pblica General GNU
  (GNU/GPL) para mas detalles.
************************************************************************
        HA manejo del archivo
*************************************************************************/

#define MYVER   2                     /* Informacion de version en archivos */
#define LOWVER  2                     /* Menor version soportada            */

enum {M_CPY=0,M_ASC,M_HSC,M_UNK,M_DIR=14,M_SPECIAL};  /* Metodos */

#define ARC_OLD 0                       /* Seales de modo para arc_open() */
#define ARC_NEW 1		
#define ARC_RDO 2

#define T_DIR           1               /* Tipos para comprobacion del tipo */
#define T_SPECIAL       2               /* de archivo                       */
#define T_SKIP          3
#define T_REGULAR       4

#define MSDOSMDH        1               /* Identificadores para la cabecera */
#define UNIXMDH         2               /* de datos especificos del S.O.    */

typedef struct {                      /* Cabecera del fichero en el archivo */
    unsigned char type;
    unsigned char ver;
    U32B clen;
    U32B olen;
    U32B time;
    U32B crc;
    char *path;
    char *name;
    unsigned mdilen;
    unsigned mylen;
} Fheader;

extern int arcfile;                     /* Manejador del archivo         */ 
extern char *arcname;                   /* Nombre del archivo            */
extern struct stat arcstat;             /* Estado del archivo (al abrir) */

void arc_open(char *arcname, int mode);
void arc_reset(void);	
Fheader *arc_seek(void);
void arc_delete(void);
void arc_newfile(char *mdpath, char *name);
int arc_adddir(void);
int arc_addspecial(char *fullname);
void arc_accept(int method);
void arc_trynext(void);
int arc_addfile(void);







