/***********************************************************************
  Este fichero es parte de BeHA, un compresor de proposito general.
  Copyright (C) 2000 Industrias O.S.G.
  Copyright (C) 1995 Harri Hirvola

  Este programa es software libre; puedes redistribuirlo y/o modificarlo
  bajo los terminos de la Licencia Publica General GNU (GNU/GPL) publicada
  por la Fundacion de Software Libre (FSF); sea la versin 2 de la Licencia,
  o (a tu opinion) o cualquier version posterior.

  Este programa es distribuido con la esperanza de que sea util, pero
  SIN NINGUNA GARANTIA. Mira los terminos de la Licencia Pblica General GNU
  (GNU/GPL) para mas detalles.
************************************************************************
        HA manejo de errores
***********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include "ha.h"
#include "error.h"

int inerror=0,lasterror=0;

char *error_string[]={
    "Error on error handle !!!",               
    "Unknown error",
    "Command %c not implemented", 
    "Can't open archive %s",
    "Without memory in %s",
    "%s isn't an HA archive",
    "Write error on %s",
    "Read error on %s",
    "Got signal %d",
    "No files found",
    "Can't remove %s",
    "Invalid modificator inválido %c",
    "The archive needs an upper version of HA",
    "Archive created with an unsupported version",
    "Unknown compression method %d",
    "Lseek error in %s",
    "Can't open file %s",
    "Can't create directory %s",
    "CRC error",
    "Write error",
    "Can't get the file status for %s",
    "Can't open directory %s",
    "Corrupted archive !",
    "Incorrect size for %s",
    "Impossible to hand %s",
    "Can't read symlink %s",
    "Can't link %s to %s",
    "Can't do fifo %s",
};


void error(int fatal, int number, ...) {
    
    va_list argptr;
    
    fflush(stdout);
    if (inerror) {
	fprintf(stderr,"\n%s: ",myname);
	fprintf(stderr,error_string[0]);
	fprintf(stderr,"\n");
	fflush(stderr);	
	exit(inerror);
    }
    inerror=number;
    fprintf(stderr,"\n%s: ",myname);
    va_start(argptr,number);
    vfprintf(stderr,error_string[number],argptr);
    fprintf(stderr,"\n");
    fflush(stderr);
    if (!fatal) {
	lasterror=inerror;
	inerror=0;
	return;
    }
    cu_do(NULL);
    exit(number);
}

