/***********************************************************************
  Este fichero es parte de BeHA, un compresor de proposito general.
  Copyright (C) 2000 Industrias O.S.G.
  Copyright (C) 1995 Harri Hirvola

  Este programa es software libre; puedes redistribuirlo y/o modificarlo
  bajo los terminos de la Licencia Publica General GNU (GNU/GPL) publicada
  por la Fundacion de Software Libre (FSF); sea la versin 2 de la Licencia,
  o (a tu opinion) o cualquier version posterior.

  Este programa es distribuido con la esperanza de que sea util, pero
  SIN NINGUNA GARANTIA. Mira los terminos de la Licencia Pblica General GNU
  (GNU/GPL) para mas detalles.
************************************************************************
        HA manejo de errores
***********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include "ha.h"
#include "error.h"

int inerror=0,lasterror=0;

char *error_string[]={
    "¡¡¡ Error en el manejo de errores !!!",               
    "Error desconocido",
    "Comand %c no implementado", 
    "No se puede abrir el archivo %s",
    "Sin memoria en %s",
    "%s no es un archivo HA",
    "Error de escritura en %s",
    "Error de lectura en %s",
    "Obtenida señal %d",
    "No se encontraron ficheros",
    "No se puede remover %s",
    "Modificador inválido %c",
    "El archivo necesita una versión superior del HA",
    "Archivo creado con una versión no soportada",
    "Método de compresión desconocido %d",
    "Error lseek en %s",
    "No se puede abrir el fichero %s",
    "No se puede crear el directorio %s",
    "Error de CRC",
    "Error de escritura",
    "No se puede obtener el estado de fichero para %s",
    "No se puede abrir el directorio %s",
    "¡ Archivo corrupto !",
    "Tamaño incorrecto para %s",
    "Imposible manejar %s",
    "No se puede leer symlink %s",
    "No se puede vincular %s a %s",
    "No se puede hacer fifo %s",
};


void error(int fatal, int number, ...) {
    
    va_list argptr;
    
    fflush(stdout);
    if (inerror) {
	fprintf(stderr,"\n%s: ",myname);
	fprintf(stderr,error_string[0]);
	fprintf(stderr,"\n");
	fflush(stderr);	
	exit(inerror);
    }
    inerror=number;
    fprintf(stderr,"\n%s: ",myname);
    va_start(argptr,number);
    vfprintf(stderr,error_string[number],argptr);
    fprintf(stderr,"\n");
    fflush(stderr);
    if (!fatal) {
	lasterror=inerror;
	inerror=0;
	return;
    }
    cu_do(NULL);
    exit(number);
}

